//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_width1  2
//---- indicator parameters
extern string TimeFrame  = "Current time frame";
extern int    FastEMA    = 9;
extern double multiplier = 2;
//extern int SignalSMA=9;
//---- indicator buffers
extern bool op_cl1_Histo =true; 
extern bool cl_op_Histo  =false; 
double     MacdBuffer[];
double     SignalBuffer[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
if (op_cl1_Histo)int op_cl1_style=2;else op_cl1_style=0;
if (cl_op_Histo) int cl_op_style =2;else cl_op_style =0;
//---- drawing settings
   SetIndexStyle(0,op_cl1_style);//macd
   SetIndexStyle(1,cl_op_Histo);//sig// LINE//HISTOGRAM
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Cl1-Op-Cl ("+FastEMA+") ");
   SetIndexLabel(0,"Open-PrevClose");//MACD 
   SetIndexLabel(1,"Close-Open");//Signal
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
{
    int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { MacdBuffer[0] = limit+1; return(0); }
             if (timeFrame!=Period())
             {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                      MacdBuffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,multiplier,0,y);
                      SignalBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,multiplier,1,y);
               }      
            return(0);
            }
         
   for(i=0; i<limit; i++)
      {
      MacdBuffer[i]    =(iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_OPEN,i) -iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i+1))*multiplier;
      SignalBuffer[i]  = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_OPEN,i);
      }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}